# frozen_string_literal: true

# Se encarga del contenido del artículo y quizás otros campos que
# requieran texto largo.
class MetadataContent < MetadataTemplate
  include ActionView::Helpers::SanitizeHelper

  def default_value
    ''
  end

  def value
    sanitize(self[:value] || document.content || default_value,
             sanitize_options).tr("\r", '')
  end

  def front_matter?
    false
  end

  private

  # Etiquetas y atributos HTML a permitir
  #
  # No queremos permitir mucho más que cosas de las que nos falten en
  # CommonMark.
  #
  # TODO: Permitir una lista de atributos y etiquetas en el Layout
  #
  # XXX: Vamos a generar un reproductor de video/audio directamente
  # desde un plugin de Jekyll
  def sanitize_options
    {
      tags: %w[span],
      attributes: %w[title class lang]
    }
  end
end
